﻿@* DXCOMMENT: Configure GridView *@
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using System.Web.UI.WebControls;
@Html.DevExpress().GridView(
    settings =>
    {
        settings.Name = "GvGoodIssue";
        settings.KeyFieldName = "INVOICE_NO;GOOD_ISSUE_STATUS";
        settings.CallbackRouteValues = new { Controller = "GoodIssue", Action = "GoodIssueCallBack" };
        settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
        settings.ControlStyle.Paddings.Padding = System.Web.UI.WebControls.Unit.Pixel(0);
        settings.ControlStyle.Border.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(0);
        settings.ControlStyle.BorderBottom.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(1);

        //DIGUNAKAN UNTUK PEMANGGILAN SEARCH DATA
        settings.ClientSideEvents.BeginCallback = "onBeginCallbackGoodIssue";
        settings.ClientSideEvents.EndCallback = "OnEndCallbackGoodIssue";

        settings.CommandColumn.Visible = true;
        settings.CommandColumn.Width = System.Web.UI.WebControls.Unit.Pixel(30);
        settings.CommandColumn.ShowSelectCheckbox = true;
        settings.ClientSideEvents.SelectionChanged = "GvGoodIssue_SelectionChanged";

        settings.SettingsEditing.Mode = GridViewEditingMode.Inline;

        settings.SettingsPager.Visible = true;
        settings.Settings.ShowFilterRowMenu = false;
        settings.Settings.ShowFilterRow = false;

        settings.SettingsPager.FirstPageButton.Visible = true;
        settings.SettingsPager.LastPageButton.Visible = true;
        settings.SettingsPager.ShowNumericButtons = true;
        settings.SettingsPager.Position = System.Web.UI.WebControls.PagerPosition.Bottom;
        settings.SettingsPager.PageSizeItemSettings.Visible = true;
        settings.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "25", "50", "100" };
        settings.SettingsPager.PageSize = 10;
        settings.SettingsPager.PageSizeItemSettings.Caption = "View per page";

        settings.Settings.VerticalScrollBarMode = ScrollBarMode.Auto;
        settings.Settings.HorizontalScrollBarMode = ScrollBarMode.Auto;
        settings.Settings.VerticalScrollableHeight = 380;

        settings.Width = 1330;
        settings.Height = 310;
        settings.CommandColumn.FixedStyle = GridViewColumnFixedStyle.Left;

        settings.CommandColumn.SetHeaderTemplateContent(c =>
        {
            if (c.Column.VisibleIndex == 0)
            {
                Html.DevExpress().CheckBox(
                    chckBox =>
                    {
                        chckBox.Name = "chckBox";
                        chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GvGoodIssue.SelectAllRowsOnPage(chckBox.GetChecked());}";
                    }
                ).Render();
            }
        });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "INVOICE_NO";
                column.Caption = "Invoice No";
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.Width = Unit.Pixel(100);
                column.FixedStyle = GridViewColumnFixedStyle.Left;
                column.SetDataItemTemplateContent(container =>
                {
                    Html.DevExpress().HyperLink(hlSettings =>
                    {
                        hlSettings.Name = string.Format("hl_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                        hlSettings.NavigateUrl = "javascript:void(0)";
                        hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e){{OnHyperLinkDetailClick('{0}');}}", (container as GridViewDataItemTemplateContainer).KeyValue.ToString().Split('|')[0]);
                        hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text.ToString();
                    }).Render();
                });
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "INVOICE_DT";
                column.Caption = "Invoice Date";
                column.Width = Unit.Pixel(100);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.FixedStyle = GridViewColumnFixedStyle.Left;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "GOOD_ISSUE_STATUS";
                column.Caption = "Good Issue Status";
                column.Width = Unit.Pixel(115);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.HeaderStyle.Wrap = DefaultBoolean.True;
                //column.FixedStyle = GridViewColumnFixedStyle.Left;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "GOOD_ISSUE_PROCESS_DT";
                column.Caption = "Good Issue Date";
                column.Width = Unit.Pixel(135);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "ETD";
                column.Caption = "ETD";
                column.Width = Unit.Pixel(80);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "GOOD_ISSUE_SALES_DOC";
                column.Caption = "Sales Doc No";
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Right;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.Width = Unit.Pixel(100);
                column.HeaderStyle.Wrap = DefaultBoolean.True;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "FOB_AMOUNT";
                column.Caption = "Amount (US$)";
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Right;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.Width = Unit.Pixel(100);
                column.HeaderStyle.Wrap = DefaultBoolean.True;
            });
        
        settings.Columns.Add(
            column =>
            {
                column.FieldName = "PACKING_COMPANY";
                column.Caption = "Packing Company";
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Right;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.Width = Unit.Pixel(150);
                column.HeaderStyle.Wrap = DefaultBoolean.True;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "CANCEL_STATUS";
                column.Caption = "Cancel Status";
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Right;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.Width = Unit.Pixel(150);
                column.HeaderStyle.Wrap = DefaultBoolean.True;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "GOOD_ISSUE_POSTING_DT";
                column.Caption = "GI Posting Date";
                column.Width = Unit.Pixel(150);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "GOOD_ISSUE_PRICING_DT";
                column.Caption = "GI Pricing Date";
                column.Width = Unit.Pixel(150);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "GOOD_ISSUE_BASELINE_DT";
                column.Caption = "GI Base Line Date";
                column.Width = Unit.Pixel(150);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            });

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "GOOD_ISSUE_DOCUMENT_DT";
                column.Caption = "GI Document Date";
                column.Width = Unit.Pixel(150);
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.ColumnType = MVCxGridViewColumnType.DateEdit;
                column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            });

        settings.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
        {
            if (e.ButtonType == ColumnCommandButtonType.Update)
            {
                e.Visible = false;
            }
            if (e.ButtonType == ColumnCommandButtonType.Cancel)
            {
                e.Visible = false;
            }
        };

        settings.Styles.AlternatingRow.Enabled = DefaultBoolean.True;
        settings.Styles.AlternatingRow.BackColor = System.Drawing.Color.WhiteSmoke;
        
    }).Bind(Model).GetHtml()
